/* Interface for Objective-C Sequential Collection object.

   Copyright (C) 1993 R. Andrew McCallum <mccallum@cs.rochester.edu>
   Dept. of Computer Science, U. of Rochester, Rochester, NY  14627

   This file is part of the GNU Objective-C Collection library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

#ifndef __IndexedCollection_h_INCLUDE_GNU
#define __IndexedCollection_h_INCLUDE_GNU

#include <coll/KeyedCollection.h>
#include <coll/IndexedCollecting.h>

@interface IndexedCollection : KeyedCollection <IndexedCollecting>

@end

/* The only subclassResponsibilities in IndexedCollection are:

      insertElement:atIndex:
      removeElementAtIndex:
      elementAtIndex:

   but subclass will want to override others as well in order to 
   increase efficiency.  The following are especially important if
   the subclass's implementation of "elementAtIndex:" is not efficient:

      replaceElementAtIndex:with:
      swapAtIndeces::
      shallowCopyReplaceFrom:to:with:
      sortAddElement:byCalling:
      removeElement:
      firstElement
      lastElement
      shallowCopyFrom:to:
      withElementsCall:whileTrue:
      withElementsInReverseCall:whileTrue:

   and perhaps:

      appendElement:
      prependElement:
      indexOfElement:
      withElementsInReverseCall:

*/


#endif /* __IndexedCollection_h_INCLUDE_GNU */
